/*
DEUTSCH

Der in dieser Datei enthaltene Programmcode ist geistiges Eigentum des Autors (Manuel Liedel, Manuel.Liedel "at" gmail.com). Jeder Gebrauch - auer zur Verifikation experimenteller Ergebnisse der Dissertationsschrift "Sichere Mehrparteienberechnungen und datenschutzfreundliche Klassifikation auf Basis horizontal partitionierter Datenbanken" - ist ohne explizite Genehmigung des Autors untersagt. Dies schliet insbesondere kommerzielle Nutzung, Weitergabe, Modifikation und Erweiterungen ein. Auch die Verwendung zu wissenschaftlichen Zwecken bedarf der Genehmigung des Autors.

ENGLISH

The source code contained in this file is the intellectual property of the author (Manuel Liedel, Manuel.Liedel "at" gmail.com). Any use - except to verify experimental results contained in the author's PhD-Dissertation "Sichere Mehrparteienberechnungen und datenschutzfreundliche Klassifikation auf Basis horizontal partitionierter Datenbanken" - is prohibited without the author's explicit consent. This includes - but is no limited to - commercial use, redistribution, modifications and extensions. Scientific use also requires the author's explicit consent.
*/

#ifndef MATRIX_H
#define MATRIX_H

#include <stdio.h>
#include <cassert>


class Matrix
{
    public:

        mpz_t ** M;

        Matrix(int n, int m);

        inline ~Matrix()
        {
            #ifdef debug
            printf("\nMatrix-Destruktor betreten: Laenge=%d, Breite=%d",Laenge,Breite);
            #endif

            int i, j;
            for(i=Laenge; i>=0; i--){
                for(j=Breite; j>=0; j--){
                    mpz_clear(M[i][j]);}
                delete []M[i];
                M[i]=NULL;
            }


            delete []M;
            M=NULL;
            #ifdef debug
            printf("\nMatrix zerstrt");
            #endif
        }

        inline Matrix(const Matrix& Ursprungsmatrix):
        Laenge(Ursprungsmatrix.Laenge),
        Breite(Ursprungsmatrix.Breite)
        {
            int i,j;
            M=new mpz_t *[Laenge+1];
            for(i=0; i<=Laenge; i++){
                M[i]=new mpz_t[Breite+1];
            }

            assert(M!=0);//berprfe ob Speicher korrekt erzeugt

            for(i=0; i<=Laenge; i++){
                for (j=0; j<=Breite; j++){
                     mpz_init_set(M[i][j],Ursprungsmatrix.M[i][j]);
                }
            }

        }

        inline Matrix& operator=(const Matrix& Ursprungsmatrix){

        if(&Ursprungsmatrix!=this){
            for(int i=0; i<=Laenge; i++){
                for(int j=0; j<=Breite; j++){
                     mpz_set(M[i][j],Ursprungsmatrix.M[i][j]);
                }
            }
        }
        return *this;
        }



    protected:
    private:

        int Laenge;
        int Breite;
};

#endif // MATRIX_H
