/*
DEUTSCH

Der in dieser Datei enthaltene Programmcode ist geistiges Eigentum des Autors (Manuel Liedel, Manuel.Liedel "at" gmail.com). Jeder Gebrauch - auer zur Verifikation experimenteller Ergebnisse der Dissertationsschrift "Sichere Mehrparteienberechnungen und datenschutzfreundliche Klassifikation auf Basis horizontal partitionierter Datenbanken" - ist ohne explizite Genehmigung des Autors untersagt. Dies schliet insbesondere kommerzielle Nutzung, Weitergabe, Modifikation und Erweiterungen ein. Auch die Verwendung zu wissenschaftlichen Zwecken bedarf der Genehmigung des Autors.

ENGLISH

The source code contained in this file is the intellectual property of the author (Manuel Liedel, Manuel.Liedel "at" gmail.com). Any use - except to verify experimental results contained in the author's PhD-Dissertation "Sichere Mehrparteienberechnungen und datenschutzfreundliche Klassifikation auf Basis horizontal partitionierter Datenbanken" - is prohibited without the author's explicit consent. This includes - but is no limited to - commercial use, redistribution, modifications and extensions. Scientific use also requires the author's explicit consent.
*/

#ifndef SHARE_F2M_H
#define SHARE_F2M_H
#include <GF256.h>
#include <cstdlib>
#include <string>
#include <vector>


class Share_F2M
{
    public:
        int Anzahl_Spieler;
        int Schwellenwert;
        GF256 * Vector;

        Share_F2M(int n, int t);
        virtual ~Share_F2M();
        Share_F2M(const Share_F2M& other);

        Share_F2M& operator=(const Share_F2M& other);
        Share_F2M& operator*=(int Faktor);
        Share_F2M& operator+=(int Faktor);
        Share_F2M operator*(const Share_F2M& Faktor);
        Share_F2M& operator*=(const Share_F2M& Faktor);

        void Erzeugung(GF256 Wert);//Share-Erzeugung mittels dividierter Differenzen
        void Erzeugung_GRR(GF256 Wert);//Share-Erzeugung mittels Polyomauswertung
        void Rekonstrukt(GF256& s, int t);//mit dividierten Differenzen;
        void Rekonstrukt_Ausgabe(std::string N, int t);
        void Rekonstrukt_GRR(GF256& Wert, int t);//Rekonstruktion mittels Lagrange-Interpolation
        void Rekonstrukt_Spieler_beliebig(GF256 * s, int * Spielerliste, int t);//Rekonstruktion mit beliebigen Spielern - abgeleitet von Share-Version
        void Zufall();//Zufallszahlen auf Positionen 1,...,t des Vektors

        void Add(Share_F2M Summand_2);//Zweiten Share addieren
        void Add_Konst_int(int Konstante);//Konstante addieren
        void Mul(const Share_F2M& Faktor_2);//Multiplikation zweier Shares; nach Lory_2; getestet am 30.3.2011
        void Mul_Konst(GF256 Konstante);
        void Mul_Konst_int(int c);

        void RandNumbers(std::vector<Share_F2M> * randNumbers, int t, const Share_F2M& a, const Share_F2M& b);//Hilfsprogramm fr Multiplikation
        void LagIntKoeff(GF256 *lambda, int n, char *name);//Hilfprogramm fr Multiplikation GRR
        void Mul_GRR(const Share_F2M& b, int t);

        void PreOr_Bits_nicht_cR(std::vector<Share_F2M>& Faktoren, int Anzahl_Faktoren);//PreOr fr Biteingabe; alle bis hier getestet am 4.4.11
        void FindFirst(std::vector<Share_F2M>& VektorF2M, std::vector<Share_F2M>& Index, int l);//Findet erstes 1-Element eines Vektors und speichert es in Index
        void BitAdd_F2M(std::vector<Share_F2M>& a, std::vector<Share_F2M>& b, int k);//Bitweise Addition von bitweisen c und r; Ergebnis in c
        void BitAdd_F2M_offen(std::vector<Share_F2M> *c, int * r, int k);//Bitweise Addition von bitweisen c und r; r offen; Ergebnis landet in a; getestet am 5.4.11
    protected:
    private:
};

#endif // SHARE_F2M_H
