/*
DEUTSCH

Der in dieser Datei enthaltene Programmcode ist geistiges Eigentum des Autors (Manuel Liedel, Manuel.Liedel "at" gmail.com). Jeder Gebrauch - auer zur Verifikation experimenteller Ergebnisse der Dissertationsschrift "Sichere Mehrparteienberechnungen und datenschutzfreundliche Klassifikation auf Basis horizontal partitionierter Datenbanken" - ist ohne explizite Genehmigung des Autors untersagt. Dies schliet insbesondere kommerzielle Nutzung, Weitergabe, Modifikation und Erweiterungen ein. Auch die Verwendung zu wissenschaftlichen Zwecken bedarf der Genehmigung des Autors.

ENGLISH

The source code contained in this file is the intellectual property of the author (Manuel Liedel, Manuel.Liedel "at" gmail.com). Any use - except to verify experimental results contained in the author's PhD-Dissertation "Sichere Mehrparteienberechnungen und datenschutzfreundliche Klassifikation auf Basis horizontal partitionierter Datenbanken" - is prohibited without the author's explicit consent. This includes - but is no limited to - commercial use, redistribution, modifications and extensions. Scientific use also requires the author's explicit consent.
*/

#ifndef VEKTOR_H
#define VEKTOR_H

#include<stdio.h>
#include<time.h>
#include<cassert>
#include<gmp.h>

class Vektor
{
    public:
        mpz_t * Vector;
        int Laenge;

        Vektor(int n); //Konstruktor
        Vektor();//Standard-Konstruktor
        virtual ~Vektor();//Destruktor
        Vektor(const Vektor& Ursprungsvektor);//Copy-Konstruktor
        Vektor& operator=(const Vektor& Ursprungsvektor);//Zuweisungsoperator

        virtual void print(char * name, int n);//Ausgabe

        virtual void Plus_Vektor(mpz_t * Summand2, int n, mpz_t& q);//Addition
        virtual void minus(mpz_t * Summand2, int n, mpz_t& q);//Subtraktion
        virtual void Mul_Konst(mpz_t& Konstante, int n, mpz_t& q);//Multiplikation mit mpz-Zahl
        virtual void Mul_Konst_int(int c, int n, mpz_t& q);//Multiplikation mit int-Zahl
        virtual void Add_Konst(mpz_t& Konstante, int n, mpz_t& q);//Addition einer mpz-Zahl
        virtual void Minus_Konst(mpz_t& Konstante, int n, mpz_t& q);//Subtrakion einer mpz-Zahl

        virtual void Zufall(int n, int t,mpz_t& p);//Vektor mit zuflligen Elementen besetzen

    protected:
    private:


};

#endif // VEKTOR_H
