/*
DEUTSCH

Der in dieser Datei enthaltene Programmcode ist geistiges Eigentum des Autors (Manuel Liedel, Manuel.Liedel "at" gmail.com). Jeder Gebrauch - auer zur Verifikation experimenteller Ergebnisse der Dissertationsschrift "Sichere Mehrparteienberechnungen und datenschutzfreundliche Klassifikation auf Basis horizontal partitionierter Datenbanken" - ist ohne explizite Genehmigung des Autors untersagt. Dies schliet insbesondere kommerzielle Nutzung, Weitergabe, Modifikation und Erweiterungen ein. Auch die Verwendung zu wissenschaftlichen Zwecken bedarf der Genehmigung des Autors.

ENGLISH

The source code contained in this file is the intellectual property of the author (Manuel Liedel, Manuel.Liedel "at" gmail.com). Any use - except to verify experimental results contained in the author's PhD-Dissertation "Sichere Mehrparteienberechnungen und datenschutzfreundliche Klassifikation auf Basis horizontal partitionierter Datenbanken" - is prohibited without the author's explicit consent. This includes - but is no limited to - commercial use, redistribution, modifications and extensions. Scientific use also requires the author's explicit consent.
*/

#include <iostream>
#include <string>
#include <fstream>
#include <Matrix_LA.h>
#include <Vektor_LA.h>
#include <Share.h>
#include <gmp.h>
#include <head.h>
#include <SVM.h>


#define leu 1
//#define leu_quadratisch 1
//#define colon 1
//#define colon_quadratisch 1
//#define duke 1
//#define duke_quadratisch 1

//#define QR 1
#define LR 1


unsigned char antilog_table[256];
unsigned char log_table[256];
mpz_t alpha_division;
mpz_t C_0_wurzel;
mpz_t C_1_wurzel;
mpz_t E_0_wurzel;
mpz_t E_1_wurzel;
mpz_t zwei_hoch_k_hoch_minus_1;
mpz_t zwei_hoch_f;
mpz_t halb;
mpz_t eins_Wurzel;
mpz_t Wurzel_zwei_hoch_f;
mpf_t Wurzel_2;
mpz_t Wurzel_2_z;
mpz_t Drei;
mpz_t grosser_Modulus;
mpz_t kleiner_Modulus;
mpz_t rem;
mpz_t rem_q_1;
gmp_randstate_t rState1;
mpz_t * RISS;
mpz_t * lambda;
mpz_t * lambda_Rekonstrukt;
GF256 * lambda_256;
mpz_t ** RISS_Koeffizienten_q1;
mpz_t ** RISS_Koeffizienten_q;
GF256 ** RISS_Koeffizienten_F2M;
GF256 * lambda_256_Rekonstrukt;
int n_ueber_t;

int **Teilmengen;
int Anzahl;
int Theta_wurzel;
int Theta_Division;


using namespace std;

void Erstelle_Vektor(Vektor_LA& V, Vektor_LA& b, int m, int n);
void Erstelle_Gleichungssystem(Matrix_LA& M, Matrix_LA& Q, Matrix_LA& A, Vektor_LA& x, int m, int n, int Spielerzahl, int Schwellenwert, mpz_t& q, mpz_t& q_1, int k, int N);
void Berechne_alpha(const Matrix_LA& A,const Vektor_LA&d,const Vektor_LA&x,Vektor_LA&b, Share& alpha, Vektor_LA& Minimum, Vektor_LA& AM_Zq, Share& alpha_kleiner_eins, int Dimension, int n, int t, int k, mpz_t& q, mpz_t& q_1);
void Zielfunktion(Matrix_LA& Q, Vektor_LA& x, Vektor_LA& c, mpf_t& Wert, int n, int t, int k, mpz_t& q, mpz_t& q_1);
void Bestimme_Aktive_Menge(Matrix_LA& A, Vektor_LA& x, Vektor_LA& b, Vektor_LA& AM_Zq, int d, int k, int n, int t, mpz_t& q, mpz_t& q_1);

int main()
{
int i,j,n=5, t=2, KK=128, Iterationszaehler=1;
mpf_set_default_prec(300);

mpz_t s, Ende;

clock_t start, stop;

mpz_init(Ende);
mpz_init_set_ui(s,1);

mpz_t q;
mpz_t q_1;
mpz_t basis;
mpz_t modulo;
mpz_t modulo_q1;

mpz_init(q);
mpz_init(q_1);
mpz_init_set_ui(basis,2);
mpz_init(modulo);
mpz_init(modulo_q1);

mpz_pow_ui(q,basis,Modullaenge);
mpz_pow_ui(q_1,basis,63);

do{
mpz_nextprime(q,q);
mpz_nextprime(q_1,q_1);
mpz_mod_ui(modulo,q, 4);
mpz_mod_ui(modulo_q1,q_1, 4);
}
while(mpz_cmp_ui(modulo,3)!=0 || mpz_cmp_ui(modulo_q1,3)!=0); //Erzeuge geeignete Primzahl fr Berechnung des modulus (mu kongruent 3 mod 4 sein)

haupt::Berechne_Koeffizienten(n,t,KK,f,q,q_1);

mpz_init_set(grosser_Modulus,q);
mpz_init_set(kleiner_Modulus,q_1);

int Zaehler_voller_Schritt=0, Zaehler_halber_Schritt=0;

mpz_t unendlich;
mpz_init_set_ui(unendlich,1);
mpz_mul_2exp(unendlich,unendlich,KK-2);
mpz_sub_ui(unendlich,unendlich,1);//unendlich=2^{k-1}-1

#ifdef leu
Matrix_mpf_t Daten(38,7130);
Vektor_mpf_t x_korrekt(38);

mpf_set_d(x_korrekt.V[0],0.0);
mpf_set_d(x_korrekt.V[1],0.0007037378410163503);
mpf_set_d(x_korrekt.V[2],2.738219115626705e-005);
mpf_set_d(x_korrekt.V[3],0.0002661991887693762);
mpf_set_d(x_korrekt.V[4],0.0);
mpf_set_d(x_korrekt.V[5],1.11746574570356e-005);
mpf_set_d(x_korrekt.V[6],0.000611988340406431);
mpf_set_d(x_korrekt.V[7],0.0004940540806878521);
mpf_set_d(x_korrekt.V[8],0.0002199832793215027);
mpf_set_d(x_korrekt.V[9],0.0006233535553629146);
mpf_set_d(x_korrekt.V[10],0.000368738130907603);
mpf_set_d(x_korrekt.V[11],0.001084491724119105);
mpf_set_d(x_korrekt.V[12],0.0);
mpf_set_d(x_korrekt.V[13],0.0002018521429914197);
mpf_set_d(x_korrekt.V[14],0.0);
mpf_set_d(x_korrekt.V[15],0.0);
mpf_set_d(x_korrekt.V[16],0.0002746316505334807);
mpf_set_d(x_korrekt.V[17],0.0004988694607769221);
mpf_set_d(x_korrekt.V[18],0.0006114602227588423);
mpf_set_d(x_korrekt.V[19],0.0);
mpf_set_d(x_korrekt.V[20],0.0);
mpf_set_d(x_korrekt.V[21],0.0006207347058335339);
mpf_set_d(x_korrekt.V[22],0.0001310930520448684);
mpf_set_d(x_korrekt.V[23],0.0001219745433488594);
mpf_set_d(x_korrekt.V[24],0.0008178010580922872);
mpf_set_d(x_korrekt.V[25],0.0001634813610327911);
mpf_set_d(x_korrekt.V[26],4.925094408131503e-005);
mpf_set_d(x_korrekt.V[27],0.001033088568627202);
mpf_set_d(x_korrekt.V[28],0.001804400380611476);
mpf_set_d(x_korrekt.V[29],0.000239783398718662);
mpf_set_d(x_korrekt.V[30],0.001059097430855059);
mpf_set_d(x_korrekt.V[31],0.0008735355459969439);
mpf_set_d(x_korrekt.V[32],0.0);
mpf_set_d(x_korrekt.V[33],0.0004599750396072778);
mpf_set_d(x_korrekt.V[34],0.001558329620175675);
mpf_set_d(x_korrekt.V[35],0.000212701065025905);
mpf_set_d(x_korrekt.V[36],0.0);
mpf_set_d(x_korrekt.V[37],0.0006613410810805574);

double b_korrekt=-0.447146;
mpf_t f_korrekt;
mpf_init_set_d(f_korrekt,-0.007903);
#endif

#ifdef leu_quadratisch
Matrix_mpf_t Daten(38,7130);
Vektor_mpf_t x_korrekt(38);

mpf_set_d(x_korrekt.V[0],0.0);
mpf_set_d(x_korrekt.V[1],0.03518230670361319);
mpf_set_d(x_korrekt.V[2],0.001389228563445081);
mpf_set_d(x_korrekt.V[3],0.01331188759841301);
mpf_set_d(x_korrekt.V[4],0.0);
mpf_set_d(x_korrekt.V[5],0.0005611960077244911);
mpf_set_d(x_korrekt.V[6],0.03055735881225561);
mpf_set_d(x_korrekt.V[7],0.0246353982334123);
mpf_set_d(x_korrekt.V[8],0.01100555465278763);
mpf_set_d(x_korrekt.V[9],0.03113865144088284);
mpf_set_d(x_korrekt.V[10],0.01839972654842207);
mpf_set_d(x_korrekt.V[11],0.05410257024708683);
mpf_set_d(x_korrekt.V[12],0.0);
mpf_set_d(x_korrekt.V[13],0.01005445587802409);
mpf_set_d(x_korrekt.V[14],0.0);
mpf_set_d(x_korrekt.V[15],0.0);
mpf_set_d(x_korrekt.V[16],0.01369005973462452);
mpf_set_d(x_korrekt.V[17],0.02489942843005731);
mpf_set_d(x_korrekt.V[18],0.03054298628732526);
mpf_set_d(x_korrekt.V[19],0.0);
mpf_set_d(x_korrekt.V[20],0.0);
mpf_set_d(x_korrekt.V[21],0.03097404579157284);
mpf_set_d(x_korrekt.V[22],0.006550508128536769);
mpf_set_d(x_korrekt.V[23],0.006117018281969215);
mpf_set_d(x_korrekt.V[24],0.04084738479673983);
mpf_set_d(x_korrekt.V[25],0.008173218014019578);
mpf_set_d(x_korrekt.V[26],0.002475143338421961);
mpf_set_d(x_korrekt.V[27],0.05160742013246438);//ab hier negative Klasse
mpf_set_d(x_korrekt.V[28],0.09008823268637441);
mpf_set_d(x_korrekt.V[29],0.01198810187077248);
mpf_set_d(x_korrekt.V[30],0.05292635056350507);
mpf_set_d(x_korrekt.V[31],0.04361851397595798);
mpf_set_d(x_korrekt.V[32],0.0);
mpf_set_d(x_korrekt.V[33],0.02300648072171758);
mpf_set_d(x_korrekt.V[34],0.0777358287744629);
mpf_set_d(x_korrekt.V[35],0.0106170968387591);
mpf_set_d(x_korrekt.V[36],0.0);
mpf_set_d(x_korrekt.V[37],0.03302010192532048);

double b_korrekt=-0.447014;
mpf_t f_korrekt;
mpf_init_set_d(f_korrekt,-0.394643);
#endif

#ifdef colon
Matrix_mpf_t Daten(30,2001);
Vektor_mpf_t x_korrekt(30);

mpf_set_d(x_korrekt.V[0],0.001687083657503246);
mpf_set_d(x_korrekt.V[1],0.002631082717828218);
mpf_set_d(x_korrekt.V[2],0.003449820954301625);
mpf_set_d(x_korrekt.V[3],0.003938151970240279);
mpf_set_d(x_korrekt.V[4],0.00158961365550937);
mpf_set_d(x_korrekt.V[5],0.001848751653980758);
mpf_set_d(x_korrekt.V[6],0.00087409795064976);
mpf_set_d(x_korrekt.V[7],0.001666007178610175);
mpf_set_d(x_korrekt.V[8],0.0005080496255244833);
mpf_set_d(x_korrekt.V[9],0.0005502448654384846);
mpf_set_d(x_korrekt.V[10],0.0);
mpf_set_d(x_korrekt.V[11],0.0007292664654302471);
mpf_set_d(x_korrekt.V[12],0.001933347899523181);
mpf_set_d(x_korrekt.V[13],0.001392388234183991);
mpf_set_d(x_korrekt.V[14],0.003122836019868257);
mpf_set_d(x_korrekt.V[15],0.002494088274429402);
mpf_set_d(x_korrekt.V[16],0.0);
mpf_set_d(x_korrekt.V[17],6.181247618752138e-005);
mpf_set_d(x_korrekt.V[18],0.0);
mpf_set_d(x_korrekt.V[19],0.0009536801935352902);
mpf_set_d(x_korrekt.V[20],0.001061966751975262);
mpf_set_d(x_korrekt.V[21],0.002597094170556967);
mpf_set_d(x_korrekt.V[22],0.0007305667795913224);
mpf_set_d(x_korrekt.V[23],0.0008712603550831134);
mpf_set_d(x_korrekt.V[24],0.0009871026479213463);
mpf_set_d(x_korrekt.V[25],0.0);
mpf_set_d(x_korrekt.V[26],0.001777719540111608);
mpf_set_d(x_korrekt.V[27],0.0);
mpf_set_d(x_korrekt.V[28],0.0);
mpf_set_d(x_korrekt.V[29],0.0);

double b_korrekt=-0.347524;
mpf_t f_korrekt;
mpf_init_set_d(f_korrekt,-0.018729);
#endif

#ifdef colon_quadratisch
Matrix_mpf_t Daten(30,2001);
Vektor_mpf_t x_korrekt(30);

mpf_set_d(x_korrekt.V[0],0.02602578140371289);
mpf_set_d(x_korrekt.V[1],0.03423608811161808);
mpf_set_d(x_korrekt.V[2],0.01849746694578573);
mpf_set_d(x_korrekt.V[3],0.02738524324068293);
mpf_set_d(x_korrekt.V[4],0.0290238482814);
mpf_set_d(x_korrekt.V[5],0.0242287066152327);
mpf_set_d(x_korrekt.V[6],0.02002858952012789);
mpf_set_d(x_korrekt.V[7],0.0238998460510916);
mpf_set_d(x_korrekt.V[8],0.00798345019560899);
mpf_set_d(x_korrekt.V[9],0.02310218342516291);
mpf_set_d(x_korrekt.V[10],0.009961338411178215);
mpf_set_d(x_korrekt.V[11],0.03075926195260311);
mpf_set_d(x_korrekt.V[12],0.03706012108962523);
mpf_set_d(x_korrekt.V[13],0.04632127586926887);
mpf_set_d(x_korrekt.V[14],0.03693711292769399);
mpf_set_d(x_korrekt.V[15],0.02609467495460025);
mpf_set_d(x_korrekt.V[16],0.01954083400944914);
mpf_set_d(x_korrekt.V[17],0.02285221576938233);
mpf_set_d(x_korrekt.V[18],0.009177950471338174);
mpf_set_d(x_korrekt.V[19],0.001969389826406242);
mpf_set_d(x_korrekt.V[20],0.01883456456279536);
mpf_set_d(x_korrekt.V[21],0.02861088503343977);
mpf_set_d(x_korrekt.V[22],0.009231423508808642);
mpf_set_d(x_korrekt.V[23],0.01884535752364217);
mpf_set_d(x_korrekt.V[24],0.0168273674157438);
mpf_set_d(x_korrekt.V[25],0.0);
mpf_set_d(x_korrekt.V[26],0.02682592001824902);
mpf_set_d(x_korrekt.V[27],0.0007687646563423519);
mpf_set_d(x_korrekt.V[28],0.005159981539461174);
mpf_set_d(x_korrekt.V[29],0.0);

double b_korrekt=0.302713;
mpf_t f_korrekt;
mpf_init_set_d(f_korrekt,-0.300096);
#endif

#ifdef duke
Matrix_mpf_t Daten(38,7130);
Vektor_mpf_t x_korrekt(38);

mpf_set_d(x_korrekt.V[0],0.0006206705338290365);
mpf_set_d(x_korrekt.V[1],0.0002246535024378646);
mpf_set_d(x_korrekt.V[2],0.001420154104024451);
mpf_set_d(x_korrekt.V[3],0.002957040640321748);
mpf_set_d(x_korrekt.V[4],0.00127081356060853);
mpf_set_d(x_korrekt.V[5],0.001031511164316221);
mpf_set_d(x_korrekt.V[6],0.001551752860746905);
mpf_set_d(x_korrekt.V[7],0.001133432136188666);
mpf_set_d(x_korrekt.V[8],0.000312588666952854);
mpf_set_d(x_korrekt.V[9],0.0001540423336580267);
mpf_set_d(x_korrekt.V[10],0.001805291005741564);
mpf_set_d(x_korrekt.V[11],0.002320442504392584);
mpf_set_d(x_korrekt.V[12],0.0002039140817325677);
mpf_set_d(x_korrekt.V[13],0.001783944275377242);
mpf_set_d(x_korrekt.V[14],0.001863960976299457);
mpf_set_d(x_korrekt.V[15],0.0009324754147303066);
mpf_set_d(x_korrekt.V[16],0.001786676647944464);
mpf_set_d(x_korrekt.V[17],0.0);
mpf_set_d(x_korrekt.V[18],0.002066132104009223);
mpf_set_d(x_korrekt.V[19],0.001169491571013092);
mpf_set_d(x_korrekt.V[20],0.002008455595720181);
mpf_set_d(x_korrekt.V[21],0.002067723329792848);
mpf_set_d(x_korrekt.V[22],0.000584437223329038);
mpf_set_d(x_korrekt.V[23],0.0001592061814764154);
mpf_set_d(x_korrekt.V[24],0.0);
mpf_set_d(x_korrekt.V[25],0.003795219951353398);
mpf_set_d(x_korrekt.V[26],0.0003481311850569071);
mpf_set_d(x_korrekt.V[27],0.0);
mpf_set_d(x_korrekt.V[28],0.0002398798010494223);
mpf_set_d(x_korrekt.V[29],0.0);
mpf_set_d(x_korrekt.V[30],0.0);
mpf_set_d(x_korrekt.V[31],0.001645282355538716);
mpf_set_d(x_korrekt.V[32],0.0);
mpf_set_d(x_korrekt.V[33],0.0005274650387891897);
mpf_set_d(x_korrekt.V[34],0.0007213775519165544);
mpf_set_d(x_korrekt.V[35],0.0004072288091995537);
mpf_set_d(x_korrekt.V[36],0.0);
mpf_set_d(x_korrekt.V[37],0.0009910281590234267);

double b_korrekt=-0.201494;
mpf_t f_korrekt;
mpf_init_set_d(f_korrekt,-0.019052);
#endif

#ifdef duke_quadratisch
Matrix_mpf_t Daten(38,7130);
Vektor_mpf_t x_korrekt(38);

mpf_set_d(x_korrekt.V[0],3.243478855960109e-007);
mpf_set_d(x_korrekt.V[1],5.90635869328691e-008);
mpf_set_d(x_korrekt.V[2],5.738501638530179e-007);
mpf_set_d(x_korrekt.V[3],1.05506397625681e-006);
mpf_set_d(x_korrekt.V[4],3.813466398786363e-007);
mpf_set_d(x_korrekt.V[5],4.645873940718977e-007);
mpf_set_d(x_korrekt.V[6],6.776502546319503e-007);
mpf_set_d(x_korrekt.V[7],4.888469857427162e-007);
mpf_set_d(x_korrekt.V[8],1.240092349189592e-007);
mpf_set_d(x_korrekt.V[9],3.380128467148818e-008);
mpf_set_d(x_korrekt.V[10],5.02680046624246e-007);
mpf_set_d(x_korrekt.V[11],7.516224057395228e-007);
mpf_set_d(x_korrekt.V[12],1.675884245492257e-007);
mpf_set_d(x_korrekt.V[13],6.213655768224026e-007);
mpf_set_d(x_korrekt.V[14],7.750674083028019e-007);
mpf_set_d(x_korrekt.V[15],1.700501901870856e-007);
mpf_set_d(x_korrekt.V[16],5.757680086212623e-007);
mpf_set_d(x_korrekt.V[17],7.027092293756611e-008);
mpf_set_d(x_korrekt.V[18],6.783540356553512e-007);
mpf_set_d(x_korrekt.V[19],4.564978156399474e-007);
mpf_set_d(x_korrekt.V[20],6.330127558576494e-007);
mpf_set_d(x_korrekt.V[21],6.868112494222045e-007);
mpf_set_d(x_korrekt.V[22],3.413542147883727e-007);
mpf_set_d(x_korrekt.V[23],1.770721128012483e-007);
mpf_set_d(x_korrekt.V[24],2.22787309190812e-007);
mpf_set_d(x_korrekt.V[25],1.175104062500625e-006);
mpf_set_d(x_korrekt.V[26],8.526231255068886e-008);
mpf_set_d(x_korrekt.V[27],8.526331893755719e-008);
mpf_set_d(x_korrekt.V[28],4.068538943923275e-008);
mpf_set_d(x_korrekt.V[29],3.025944775041957e-008);
mpf_set_d(x_korrekt.V[30],0.0);
mpf_set_d(x_korrekt.V[31],5.128982654019395e-007);
mpf_set_d(x_korrekt.V[32],0.0);
mpf_set_d(x_korrekt.V[33],1.0666046072128e-007);
mpf_set_d(x_korrekt.V[34],2.611872522149039e-007);
mpf_set_d(x_korrekt.V[35],1.607784444513643e-007);
mpf_set_d(x_korrekt.V[36],7.543509619131898e-008);
mpf_set_d(x_korrekt.V[37],2.460179116686543e-007);

double b_korrekt=-0.290858;
mpf_t f_korrekt;
mpf_init_set_d(f_korrekt,-0.000007);
#endif

int k, Anzahl_Gleichungsnebenbedingungen=1;

ifstream data;

#ifdef leu
data.open("leu.txt.scale");
#endif

#ifdef leu_quadratisch
data.open("leu.txt.scale");
#endif

#ifdef colon
data.open("cc-train.tr.scale");
#endif

#ifdef colon_quadratisch
data.open("cc-train.tr.scale");
#endif

#ifdef duke
data.open("duke.tr.scale");
#endif

#ifdef duke_quadratisch
data.open("duke.tr.scale");
#endif

if(!data)
    {
    cout<<"Datei konnte nicht geoeffnet werden. Abbruch"<<endl;
    exit(1);
    }
string Daten_String;
string Hilfsstring;
string Hilfsstring2;


char C;
while(data.get(C)){
    Daten_String+=C;//Input in Daten_String schhreiben
    }

k=0;
int counter=0;
size_t found,found_d;
double hilfe=0.0;
int Zahl;
while(!Daten_String.empty()){
    found=Daten_String.find(' ');
    Hilfsstring=Daten_String.substr(0,(int)found);
    Daten_String.erase(0,found+(size_t)1);

    found_d=Hilfsstring.find(":");
    if(found_d==string::npos){
        hilfe=atof(Hilfsstring.c_str());
        Zahl=0;
        }
    else{
        Hilfsstring2=Hilfsstring.substr(0,(int)found_d);

        Hilfsstring.erase(0,(int)found_d+1);
        Zahl=atoi(Hilfsstring2.c_str());

        hilfe=atof(Hilfsstring.c_str());
        }

    mpf_set_d(Daten.M[counter][Zahl],hilfe);

    #ifdef leu
    if(Zahl==7129){
    #endif

    #ifdef leu_quadratisch
    if(Zahl==7129){
    #endif

    #ifdef colon
    if(Zahl==2000){
    #endif

    #ifdef colon_quadratisch
    if(Zahl==2000){
    #endif

    #ifdef duke
    if(Zahl==7129){
    #endif

    #ifdef duke_quadratisch
    if(Zahl==7129){
    #endif

        found=Daten_String.find('\n');
        Daten_String.erase(0,found+(size_t)1);
        counter++;
        k++;
        }
    }

data.close();
k=KK;

Vektor_mpf_t Daten_Y(Daten.Hoehe);
Daten_Y.getSpaltenvektor(0,Daten);//Klassenindikatoren auslesen
SVM Daten_verteilt(Daten.Hoehe,Daten.Breite-1,n,t,q,q_1,k,f);

Matrix_mpf_t Daten_rechts(Daten.Hoehe,Daten.Breite-1);
Daten_rechts.Kopiere_rechts(Daten);
Daten_verteilt.Daten=Daten_rechts;
Daten_verteilt.Y.Unskaliert_einlesen(Daten_Y);
Daten_verteilt.Y.Ausgabe("Y_s");
Daten_verteilt.Lambda.Erzeugung_double(0.5,t,q);//Parameter lambda, der die Toleranz der SVM angibt

//Berechnung der Kernel-Matrix
#ifdef leu
Daten_verteilt.Linearer_Kernel();
#endif

#ifdef leu_quadratisch
Daten_verteilt.Quadratischer_Kernel(0.0001,100.0);
#endif

#ifdef colon
Daten_verteilt.Linearer_Kernel();
#endif

#ifdef colon_quadratisch
Daten_verteilt.Quadratischer_Kernel(0.01,1.0);
#endif

#ifdef duke
Daten_verteilt.Linearer_Kernel();
#endif

#ifdef duke_quadratisch
Daten_verteilt.Quadratischer_Kernel(1.0,1.0);
#endif

Vektor_LA c(Daten_verteilt.Hoehe_Daten,n,t,q,q_1,k,f);
for(i=0; i<c.d; i++){
    c[i].Erzeugung_double(-1.0,t,q);
    }

Daten_verteilt.Berechne_G();
Matrix_LA Q=Daten_verteilt.G;

Vektor_LA b(2*Daten_verteilt.K.Zeilenzahl+1,n,t,q,q_1,k,f);
for(i=1; i<Daten_verteilt.K.Zeilenzahl+1; i++){
    b[i]=-Daten_verteilt.Lambda;
    }

Matrix_LA A(b.d,Daten_verteilt.Y.d,n,t,q,q_1,k,f);
for(i=1; i<Daten_verteilt.K.Zeilenzahl+1; i++){
    A.M[i][i-1].Erzeugung_double(-1.0,t,q);
    }

for(i=Daten_verteilt.K.Zeilenzahl+1; i<A.Zeilenzahl; i++){
    A.M[i][i-Daten_verteilt.K.Zeilenzahl-1].Erzeugung_double(1.0,t,q);
    }

for(i=0; i<A.Spaltenzahl; i++){
    A.M[0][i]=Daten_verteilt.Y[i]*zwei_hoch_f;//Gleichheitsbedingung
    }

Vektor_LA x(A.Spaltenzahl,n,t,q,q_1,k,f);
x[0]=Daten_verteilt.Lambda;
x[0].Div_Konst_int(2,q,q_1,k);
x[x.d-1]=x[0];//Eine positive und eine negative Klasse (die erste und die letzte) werden mit einem positiven wert belegt, der nicht dau fhrt, dass die Ungleicungen aktiv werden

Vektor_LA S(b.d,n,t,q,q_1,k,f);

Matrix_LA G(Q.Zeilenzahl+A.Spaltenzahl,Q.Spaltenzahl+A.Spaltenzahl,n,t,q,q_1,k,f);
Vektor_LA l(Q.Zeilenzahl+A.Spaltenzahl,n,t,q,q_1,k,f);
Vektor_LA lambda(b.d,n,t,q,q_1,k,f);
Vektor_LA lambda_min=lambda;
Vektor_LA lambda_kurz(A.Spaltenzahl-Anzahl_Gleichungsnebenbedingungen,n,t,q,q_1,k,f);
Share Bit(n,t,q);
Share Hilfe(n,t,q);
Share Hilfe2(n,t,q);
Share lambda_q (n,t,q);//Speichere das aktuelle lambda
Vektor_LA Hilfe_Vektor(A.Spaltenzahl,n,t,q,q_1,k,f);
Share alpha(n,t,q);
Vektor_LA d(x.d,n,t,q,q_1,k,f);
Vektor_LA Index(A.Zeilenzahl,n,t,q,q_1,k,f);//wird zur Bestimmung des Minimums von alpha bentigt
Vektor_LA Index_kurz(A.Spaltenzahl-Anzahl_Gleichungsnebenbedingungen,n,t,q,q_1,k,f);
Vektor_LA Index_kurz_mit_GHNB(A.Spaltenzahl,n,t,q,q_1,k,f);
Vektor_LA Index_AM(A.Zeilenzahl,n,t,q,q_1,k,f);
Vektor_LA ax(A.Zeilenzahl,n,t,q,q_1,k,f);
Vektor_LA AM_Zq(b.d,n,t,q,q_1,k,f);
Vektor_LA Kopie_AM(b.d,n,t,q,q_1,k,f);
Vektor_LA AM_kurz(A.Spaltenzahl,n,t,q,q_1,k,f);
Matrix_LA Kopie_A=A;
Matrix_LA Merke_A=Kopie_A;//Speichere die Matrix A mit den temporren VZ der GHNB
Vektor_LA Kopie_b=b;//Dito fr die entsprechenden Zeilen von b
Matrix_LA A_Kompakt(A.Spaltenzahl,A.Spaltenzahl,n,t,q,q_1,k,f);
Vektor_LA Kopie_c=c;
Vektor_LA Kopie_x=x;
Vektor_LA Ergebnis=x;
Share Hilfe_2=Hilfe;
Matrix_LA P(A.Zeilenzahl,A.Zeilenzahl,n,t,q,q_1,k,f);
Matrix_LA P_t(A.Zeilenzahl,A.Zeilenzahl,n,t,q,q_1,k,f);//Die Transponierte von P
Share alpha_kleiner_eins(n,t,q);

mpz_t eins;
mpz_init_set_ui(eins,1);

mpz_t epsilon;
mpz_init_set_ui(epsilon,1);
mpz_mul_2exp(epsilon,epsilon,f-30);

time_t start_Phase2,stop_Phase_2;
///Beginn Phase 2
Share Eins(n,t,q);
Eins.Erzeugung(eins,t,q);


AM_Zq[0]=Eins;
for(i=Daten_verteilt.K.Zeilenzahl+2; i<A.Zeilenzahl-1; i++){
    AM_Zq[i]=Eins; //Die Variablen 2,...,m-1 sind 0, also die entsprechenden Ungleichungen aktiv
    }

start_Phase2=clock();

for(i=0; i<A.Zeilenzahl; i++){//Bestimme die initialen Werte ax(i)
    Hilfe_Vektor.getZeilenvektor(A,i);
    Hilfe_Vektor.SkalarMult(x,ax[i]);
    }

for(Iterationszaehler=1; Iterationszaehler<501; Iterationszaehler++){

Kopie_c=c;
Kopie_x=x;

Kopie_x.MatrixMult(Q,Kopie_x);
Kopie_x.TruncPr();
Kopie_c+=Kopie_x;//Kopie_c=Q*x+c

Kopie_A.Multipliziere_Zeilenweise(&AM_Zq.Vector_LA);
Kopie_A.Matrix_Zusammenschieben_binaer(AM_Zq.Vector_LA,P);

A_Kompakt.Oben_einpassen(Kopie_A);

P_t=P;
P_t.Transponiere_quadratisch();

AM_Zq.MatrixMult(P,Kopie_AM);

AM_kurz.Oben_einpassen(Kopie_AM);

G=0;
l=0;
Erstelle_Gleichungssystem(G,Q,A_Kompakt,x,A_Kompakt.Zeilenzahl,A_Kompakt.Spaltenzahl,n,t,q,q_1,k,f);
Erstelle_Vektor(l,Kopie_c,c.d,l.d);

#ifdef QR
G.Loese_GLS_QR(l.Vector_LA,l.d);
#endif

#ifdef LR
G.Loese_GLS_LR(l.Vector_LA,l.d);
#endif

j=0;
for(i=c.d; i<l.d; i++){
    lambda.Vector_LA.at(j)=l.Vector_LA.at(i);
    j++;
    }

lambda.MatrixMult(P_t,lambda);//Setze lambda an die richtigen Stellen zurck; die ungltigen Stellen werden automatisch mit Null besetzt

for(i=0; i<lambda_kurz.d; i++){
    lambda_kurz[i]=l[i+c.d+Anzahl_Gleichungsnebenbedingungen];//Kompaktifizierte Form des Vektors lambda erstellen
    lambda_kurz[i]=lambda_kurz[i]*AM_kurz[i+Anzahl_Gleichungsnebenbedingungen]+(-AM_kurz[i+Anzahl_Gleichungsnebenbedingungen]+1)*unendlich;//Ersetze nicht-aktive Komponenten mit unendlich; diese sind wg. Komplementrbedingung = 0
    }

for(i=0; i<x.d; i++){
    d.Vector_LA.at(i)=l.Vector_LA.at(i);
    }

d.Gleich_Null_approximativ(Bit);

///Schritt 3
Index_kurz=0;
lambda_kurz.Min(Index_kurz,k);
Index_kurz_mit_GHNB.Kopiere_unten(Index_kurz);

lambda_q=0;
lambda_q=lambda_kurz[Index_kurz];

///Verkrzten Vektor lambda wieder auf die richtige Lnge expandieren
lambda_min.Oben_einpassen(Index_kurz_mit_GHNB);
lambda_min.MatrixMult(P_t,lambda_min);

lambda_q.GTZ_approximativ(t,q,q_1,k);
lambda_q.MulPub(Bit,Ende);

if(mpz_cmp_si(Ende,1)==0){
    stop_Phase_2=clock();
    FILE* datei1;
    datei1=fopen("Ausgabe.txt","a");

    fprintf(datei1,"\n\n\n---------------------------------------------------");
    time_t Zeit;
    struct tm *ts;//Variable zur Zeitmessung
    time(&Zeit);
    ts=localtime(&Zeit);
    fprintf(datei1,"\n\n\nZeit: %s\n\n",asctime(ts));

    cout<<"\n\nOptimaler Punkt x erreicht"<<endl;
    Q.Ausgabe_skaliert("Q");
    c.Ausgabe_skaliert("c");
    A.Ausgabe_skaliert("A");
    b.Ausgabe_skaliert("b");

    Q.Ausgabe_skaliert_Datei("Q",datei1);
    c.Ausgabe_skaliert_Datei("c",datei1);
    A.Ausgabe_skaliert_Datei("A",datei1);
    b.Ausgabe_skaliert_Datei("b",datei1);
    fprintf(datei1,"\nOptimaler Punkt x erreicht");

    fprintf(datei1,"\nLaufzeit des Programms: %f s",((double)stop_Phase_2-(double)start_Phase2)/CLOCKS_PER_SEC);
    printf("\nZeit fuer Phase 2: %f s",((double)stop_Phase_2-(double)start_Phase2)/CLOCKS_PER_SEC);
    printf("\n\nAnzahl der Iterationen: %d", Iterationszaehler);
    printf("\nAnzahl volle Schritte: %d",Zaehler_voller_Schritt);
    printf("\nAnzahl halbe Schritte: %d",Zaehler_halber_Schritt);
    fprintf(datei1,"\n\nAnzahl der Iterationen: %d", Iterationszaehler);
    fprintf(datei1,"\nAnzahl volle Schritte: %d",Zaehler_voller_Schritt);
    fprintf(datei1,"\nAnzahl halbe Schritte: %d\n\n",Zaehler_halber_Schritt);
    mpf_t Z;
    mpf_init(Z);
    Zielfunktion(Q,x,c,Z,n,t,k,q,q_1);
    gmp_printf("\nZielfunktion: %.10Ff",Z);
    gmp_fprintf(datei1,"\nZielfunktion: %.10Ff",Z);
    mpf_sub(Z,Z,f_korrekt);
    gmp_printf("\nDifferenz zu exaktem Wert der Zielfunktion: %.10Fe",Z);
    gmp_fprintf(datei1,"\nDifferenz zu exaktem Wert der Zielfunktion: %.10Fe",Z);
    mpf_div(Z,Z,f_korrekt);
    gmp_printf("\nRelativer Fehler der Zielfunktion: %.10Fe",Z);
    gmp_fprintf(datei1,"\nRelativer Fehler der Zielfunktion: %.10Fe",Z);
    Vektor_mpf_t x_Werte(x.d);
    x.Ausgabe_skaliert_Vektor_mpf_t(x_Werte);
    x_Werte-=x_korrekt;
    x_Werte.Ausgabe_wissenschaftlich("x_Diff");
    x_Werte.Ausgabe_wissenschaftlich_Datei("x_Diff",datei1);
    double Norm_Differenz=x_Werte.Norm();
    printf("\n\nNorm der Differenz: %e",Norm_Differenz);
    fprintf(datei1,"\n\nNorm der Differenz: %e", Norm_Differenz);
    Norm_Differenz=Norm_Differenz/x_korrekt.Norm();
    printf("\nRelativer Fehler der Norm: %e",Norm_Differenz);
    fprintf(datei1,"\nRelativer Fehler der Norm: %e", Norm_Differenz);
    for(i=0; i<x.d; i++){
        x[i].Rekonstrukt(s,t,q);
        mpf_set_z(Z,s);
        mpf_div_2exp(Z,Z,f);
        gmp_fprintf(datei1,"\nx(%d)=%.10Ff",i,Z);
        }
    x.Ausgabe_skaliert("x");

    AM_Zq.Ausgabe("AM");

    Daten_verteilt.Berechne_SV();
    Daten_verteilt.Alpha=x;
    Daten_verteilt.Berechne_b();

    mpf_set_z(Z,s);
    mpf_div_2exp(Z,Z,f);
    mpf_t bf;
    mpf_init_set_d(bf,b_korrekt);
    mpf_add(Z,Z,bf);
    Daten_verteilt.Alpha=x;
    Daten_verteilt.Berechne_SV();
    Daten_verteilt.Berechne_b();
    Daten_verteilt.b.Rekonstrukt_Ausgabe("b");
    Daten_verteilt.b.Ausgabe_skaliert_Datei("b",datei1);
    Daten_verteilt.b.Rekonstrukt_GRR_mit_VZ(s,q,t);
    printf("\n\nkorrektes b: %f",b_korrekt);
    fprintf(datei1,"\n\nkorrektes b: %f",b_korrekt);
    gmp_printf("\nAbsoluter Fehler in b: %Ff",Z);
    gmp_fprintf(datei1,"\nAbsoluter Fehler in b: %Ff",Z);
    mpf_div(Z,Z,bf);
    gmp_printf("\nRelativer Fehler in b: %Ff",Z);
    gmp_fprintf(datei1,"\nRelativer Fehler in b: %Ff",Z);

    fclose(datei1);
    break;
    }
///Schritt 2
//d auf Null setzen, falls der (appr.) Test dies ergibt; korrigiere so fr Vektoren, die nur auf Grund von Rundungsfehlern!=0 sind
Hilfe=Bit;
Hilfe*=-1;
Hilfe+=1;
for(i=0; i<x.d; i++){
    d[i]=d[i]*Hilfe;
    }

Berechne_alpha(A,d,x,b,alpha,Index,AM_Zq,alpha_kleiner_eins,A.Zeilenzahl,n,t,k,q,q_1);

Hilfe=Bit;
Hilfe*=-1;
Hilfe.Add_Konst_int(1,q);//Hilfe=1-(d=?0)
d*=alpha;
d*=Hilfe;//korrigiere d
d.TruncPr();
x+=d;//x_{k+1}=x_k+alpha_k*d_k

Hilfe=Bit;

Index*=alpha_kleiner_eins;//Index_AM=Index_AM*(alpha_k<?1)
Hilfe*=-1;
Hilfe.Add_Konst_int(1,q);//Hilfe=1-(d=?0)
Index_AM*=Hilfe;//Index=Index_AM*(alpha_k<?=1)*(1-(d=?0))
AM_Zq+=Index;//W_{k+1}=W_k+I*(alpha<?0)*(1-(d=?0))

lambda_min*=-1;
lambda_min*=Bit;
AM_Zq+=lambda_min;//W_{k+1}=W_k+I*(alpha<?0)*(1-(d=?0))-d*I_lambda_min

for(i=0; i<A.Zeilenzahl; i++){//Bestimme die neuen Werte ax(i)
    Hilfe_Vektor.getZeilenvektor(A,i);
    Hilfe_Vektor.SkalarMult(x,ax[i]);
    }

Kopie_A=A;
Kopie_x=x;
Kopie_c=c;
}

Daten_verteilt.Alpha=x;//Lsungsvektor in den Scope der SVM schreieben
Daten_verteilt.Berechne_SV();
Daten_verteilt.Berechne_b();
Daten_verteilt.SV.Ausgabe("SV");
Daten_verteilt.Entscheidungsregel_Test("Ausgabe.txt");

ifstream data_test;

#ifdef leu
Daten_verteilt.Save_SVM("leu");
Matrix_mpf_t Daten_Test(34,7130);
data_test.open("leu.t.scale");
#endif

#ifdef leu_quadratisch
Daten_verteilt.Save_SVM("leu");
Matrix_mpf_t Daten_Test(34,7130);
data_test.open("leu.t.scale");
#endif

#ifdef colon
Daten_verteilt.Save_SVM("colon");
Matrix_mpf_t Daten_Test(32,2001);
data_test.open("cc-test.scale");
#endif

#ifdef colon_quadratisch
Daten_verteilt.Save_SVM("colon");
Matrix_mpf_t Daten_Test(32,2001);
data_test.open("cc-test.scale");
#endif

#ifdef duke
Daten_verteilt.Save_SVM("duke");
Matrix_mpf_t Daten_Test(4,7130);
data_test.open("duke.val.scale");
#endif

#ifdef duke_quadratisch
Daten_verteilt.Save_SVM("duke");
Matrix_mpf_t Daten_Test(4,7130);
data_test.open("duke.val.scale");
#endif

if(!data_test)
    {
    cout<<"Datei konnte nicht geoeffnet werden. Abbruch"<<endl;
    exit(1);
    }
string Daten_String_Test;
string Hilfsstring_Test;
string Hilfsstring2_Test;


while(data_test.get(C)){
    Daten_String_Test+=C;//Input in Daten_String schreiben
    }

k=0;
 counter=0;
hilfe=0.0;

while(!Daten_String_Test.empty()){
    found=Daten_String_Test.find(' ');
    Hilfsstring_Test=Daten_String_Test.substr(0,(int)found);
    Daten_String_Test.erase(0,found+(size_t)1);

    found_d=Hilfsstring_Test.find(":");
    if(found_d==string::npos){
        hilfe=atof(Hilfsstring_Test.c_str());
        Zahl=0;
        }
    else{
        Hilfsstring2_Test=Hilfsstring_Test.substr(0,(int)found_d);

        Hilfsstring_Test.erase(0,(int)found_d+1);
        Zahl=atoi(Hilfsstring2_Test.c_str());

        hilfe=atof(Hilfsstring_Test.c_str());
        }

    mpf_set_d(Daten_Test.M[counter][Zahl],hilfe);

    #ifdef leu
    if(Zahl==7129){
    #endif

    #ifdef leu_quadratisch
    if(Zahl==7129){
    #endif

    #ifdef colon
    if(Zahl==2000){
    #endif

    #ifdef colon_quadratisch
    if(Zahl==2000){
    #endif

    #ifdef duke
    if(Zahl==7129){
    #endif

    #ifdef duke_quadratisch
    if(Zahl==7129){
    #endif

        found=Daten_String_Test.find('\n');
        Daten_String_Test.erase(0,found+(size_t)1);
        counter++;
        k++;
        }
    }

data_test.close();

Vektor_mpf_t Daten_Y_Test(Daten_Test.Hoehe);
Daten_Y_Test.getSpaltenvektor(0,Daten_Test);//Klassenindikatoren auslesen
SVM Daten_verteilt_Test(Daten_Test.Hoehe,Daten_Test.Breite-1,n,t,q,q_1,k,f);
Matrix_mpf_t Daten_rechts_Test(Daten_Test.Hoehe,Daten_Test.Breite-1);
Daten_rechts_Test.Kopiere_rechts(Daten_Test);
Daten_verteilt_Test.Daten=Daten_rechts_Test;

Daten_verteilt_Test.Y.Unskaliert_einlesen(Daten_Y_Test);
Daten_verteilt_Test.Lambda=Daten_verteilt.Lambda;//Parameter lambda, der die Toleranz der SVM angibt

start=clock();

#ifdef leu
Daten_verteilt.SVM_Test_linear(Daten_verteilt_Test.Daten,Daten_verteilt_Test.Y,"Ausgabe.txt");

#elif colon
Daten_verteilt.SVM_Test_linear(Daten_verteilt_Test.Daten,Daten_verteilt_Test.Y,"Ausgabe.txt");

#elif duke
Daten_verteilt.SVM_Test_linear(Daten_verteilt_Test.Daten,Daten_verteilt_Test.Y,"Ausgabe.txt");
#endif

#ifdef leu_quadratisch
Daten_verteilt.SVM_Test_quadratisch(Daten_verteilt_Test.Daten,Daten_verteilt_Test.Y,"Ausgabe.txt");

#elif colon_quadratisch
Daten_verteilt.SVM_Test_quadratisch(Daten_verteilt_Test.Daten,Daten_verteilt_Test.Y,"Ausgabe.txt");

#elif duke_quadratisch
Daten_verteilt.SVM_Test_quadratisch(Daten_verteilt_Test.Daten,Daten_verteilt_Test.Y,"Ausgabe.txt");
#endif
stop=clock();

FILE * datei1;
printf("\n\nZeit fuer Verifikation: %f s",((double)stop-(double)start)/CLOCKS_PER_SEC);
datei1=fopen("Ausgabe.txt","a");
fprintf(datei1,"\nZeit fuer Verifikation: %f s",((double)stop-(double)start)/CLOCKS_PER_SEC);
getchar();

mpz_clear(s);
mpz_clear(unendlich);
return 0;
}

void Berechne_alpha(const Matrix_LA& A, const Vektor_LA& d, const Vektor_LA&x, Vektor_LA& b, Share& alpha, Vektor_LA& Index, Vektor_LA& AM_Zq, Share& alpha_kleiner_eins, int Dimension, int n, int t, int k, mpz_t& q, mpz_t& q_1){

int i;
Vektor_LA ax(Dimension, n, t, q, q_1, k, f);
Vektor_LA ad(Dimension, n, t, q, q_1, k, f);
Vektor_LA ad_Vergleich_Null(Dimension, n, t, q, q_1, k, f);
Vektor_LA Hilfe_Vektor(A.Spaltenzahl, n, t, q, q_1, k, f);
Vektor_LA eins_minus_AM_Zq=AM_Zq;
Vektor_LA Kriterium(Dimension, n, t, q, q_1, k, f);
Vektor_LA Kriterium_Komplement(Dimension, n, t, q, q_1, k, f);
Vektor_LA alpha_ad(Dimension, n, t, q, q_1, k, f);

mpz_t unendlich;
mpz_init_set_ui(unendlich,1);
mpz_mul_2exp(unendlich,unendlich,k-1);
mpz_sub_ui(unendlich,unendlich,1);

mpz_t minus_eins;
mpz_init_set(minus_eins,zwei_hoch_f);
mpz_mul_si(minus_eins,minus_eins,-1);

for(i=0; i<Dimension; i++){
    Hilfe_Vektor.getZeilenvektor(A,i);
    Hilfe_Vektor.SkalarMult(x,ax[i]);
    ax[i].TruncPr(k,f,t,q,q_1);
    }

for(i=0; i<A.Zeilenzahl; i++){
    Hilfe_Vektor.getZeilenvektor(A,i);
    Hilfe_Vektor.SkalarMult(d,ad[i]);

    ad[i].TruncPr(k,f,t,q,q_1);
    ad_Vergleich_Null[i]=ad[i];//berprfe, ob ad[i]<0 ist; die betreffenden Komponenten werden bei der Berechnung von alpha nicht betrachtet
    ad_Vergleich_Null[i].LTZ_approximativ(t,q,q_1,k);

    eins_minus_AM_Zq[i].Mul_Konst_int(-1,q);
    eins_minus_AM_Zq[i].Add_Konst_int(1,q);//eins_minus_AM_Zq[i]=1-AM_Zq[i]

    Kriterium[i]=eins_minus_AM_Zq[i];
    Kriterium[i].AND(ad_Vergleich_Null[i]);
    Kriterium_Komplement[i]=Kriterium[i];
    Kriterium_Komplement[i]*=-1;
    Kriterium_Komplement[i]+=1;

    alpha_ad[i]=b[i]-ax[i];
    alpha_ad[i]=Kriterium[i]*alpha_ad[i]-Kriterium_Komplement[i]*unendlich;
    ad[i]=Kriterium[i]*ad[i]+Kriterium_Komplement[i]*minus_eins;//nicht anwendbare Nenner auf Eins setzen
    }

alpha_ad.Min_Bruch(ad,Index);
Share Zaehler(n,t,q);
Share Nenner(n,t,q);
Zaehler=alpha_ad[Index];

Nenner=ad[Index];

alpha=Zaehler;
alpha.FPDiv(Nenner,t,q,q_1,k);//alpha=min((alpha_ad[i]-ax[i])/ad[i])

Zaehler=alpha;
Zaehler.LT(zwei_hoch_f,t,q,q_1,k);//berprfe, ob das Minimum grer 1 ist

alpha_kleiner_eins=Zaehler;
alpha=Zaehler*alpha+(-Zaehler+1)*zwei_hoch_f;

mpz_clear(minus_eins);
mpz_clear(unendlich);
}

void Zielfunktion(Matrix_LA& Q, Vektor_LA& x, Vektor_LA& c, mpf_t& Wert, int n, int t, int k, mpz_t& q, mpz_t& q_1){

Share Ergebnis(n,t,q);
Share Ergebnis2(n,t,q);
mpz_t z;
mpz_init(z);

Vektor_LA Kopie_x=x;
Kopie_x.MatrixMult(Q,Kopie_x);
Kopie_x.SkalarMult(x,Ergebnis);
Ergebnis.TruncPr(2*k,2*f,t,q,q_1);
Ergebnis.Div_Konst_int(2,q,q_1,k);

x.SkalarMult(c,Ergebnis2);
Ergebnis2.TruncPr(k,f,t,q,q_1);

Ergebnis+=Ergebnis2;
Ergebnis.Rekonstrukt(z,t,q);

mpf_set_z(Wert,z);
mpf_div_2exp(Wert,Wert,f);

mpz_clear(z);
}

void Erstelle_Gleichungssystem(Matrix_LA& M, Matrix_LA& Q, Matrix_LA& A, Vektor_LA& x, int m, int n, int Spielerzahl, int Schwellenwert, mpz_t& q, mpz_t& q_1, int k, int N){
//Erstelle das Gleichungssystem, dessen Lsung Lsung des Optimierungsproblems unter den Gleichheitsbedingungen ist

int i,j,l;

if(n!=A.Spaltenzahl){
    printf("\nFehler: Erstelle_Gleichungssystem. A.Spaltenahl!=n. Abbruch");
    printf("\nA.Spaltenzahl=%d, n=%d",A.Spaltenzahl,n);
    exit(1);
    }

for(i=0; i<Q.Zeilenzahl; i++){//Linke obere Ecke mit Q befllen
    for(j=0; j<Q.Spaltenzahl; j++){
        M.M[i][j]=Q.M[i][j];
        }
    l=0;
    for(j=Q.Spaltenzahl;j<Q.Spaltenzahl+A.Zeilenzahl; j++){//Rechte obere Ecke mit -A^t befllen
            M.M[i][j]=-A.M[l][i];
        l++;
    }
}

l=0;
for(i=Q.Zeilenzahl; i<Q.Zeilenzahl+A.Zeilenzahl; i++){
    for(j=0; j<A.Spaltenzahl; j++){
        M.M[i][j]=A.M[l][j];
        }
    l++;
    }
}

void Erstelle_Vektor(Vektor_LA& V, Vektor_LA& b, int m, int n){//m=dim b, n=dim *this; n>=m; bentigt fr Optimierung
//Wird bentigt im Iterationsschritt der generischen aktiven Mengen Strategie
if(n<m || n<0 || m<0){
    printf("\nWarnung: Erstelle_Vektor");
    printf("\nDimensionen falsch. Erstellen des Vektors nicht mglich. Abbruch");
    exit(1);
    }

int i;

for(i=0; i<m; i++){
    V.Vector_LA.at(i)=b[i];
    V.Vector_LA.at(i)*=-1;//*this(i)=-b_i
    }
}

void Bestimme_Aktive_Menge(Matrix_LA& A, Vektor_LA& x, Vektor_LA& b, Vektor_LA& AM_Zq, int d, int k, int n, int t, mpz_t& q, mpz_t& q_1){//Bestimmung der aktiven Menge

int i;
mpz_t z;
mpz_init(z);

Vektor_LA Hilfsvektor=x;
Hilfsvektor.MatrixMult(A,AM_Zq);
AM_Zq.TruncPr();
AM_Zq-=b;

mpz_set_ui(z,8);
for(i=0; i<d; i++){
AM_Zq[i].Quadrat();
AM_Zq[i].TruncPr(k,f,t,q,q_1);
AM_Zq[i].LT(z,t,q,q_1,k);
}

mpz_clear(z);
}
